#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include "RmtPunch.h"


extern int		inColCount;
extern int		outColCount;
extern int		nonSpace;
extern int		cardCount;
extern int		errorCount;
extern FILE *in, *out;
extern unsigned short	cardBuffer[82];
extern unsigned short 	KeyCode[256]; /*Place to store all of the key codes*/

int getCardASCII()
{
  int columns;
  int inCol;
  
  cardCount++;
  for(columns=0;columns<82;cardBuffer[columns++]=0);  
  columns=0;
  
  for(EVER)
  {
    inCol=fgetc(in);
    if(inCol == EOF) return EOF;
    if(inCol == CR) inCol = SPACE;
    inCol=toupper(inCol);    // go to all upper case
    inColCount++;            // count the columns coming in
    		
     
    if(inCol == LF)
    {
      cardBuffer[columns++]=P14;  //release key
      outColCount+=columns;       //count the columns going out
      		 
      fwrite(cardBuffer,2,(columns),out);
	  
      return(columns);
    }

   
    if(KeyCode[inCol] == INVALID)
    {
      fprintf(stdout,"Invalid card code;\n Card number %d\n",
      cardCount);
      fprintf(stdout," Column number %d\n",
      columns);
      fprintf(stdout," Character %d >%c<\n",inCol,inCol);
      errorCount++;
    }
    cardBuffer[columns++]=KeyCode[inCol];
    
	if(columns > 80)   //80 cols (0-79) + lf
    {
      fprintf(stderr, "Card record %d exceeds 80 bytes.\n",
      cardCount);
      return(-80); // tell the sad story
    }
     
  }
}
int getCardBinary()
{
	unsigned short inWord;
	int status;
	int columns=0;

	 cardCount++;
	for(columns=0;columns<82;cardBuffer[columns++]=0);  
	columns=0;
	
	 for(EVER)
	{
		status=fread(&inWord,2,1,in);
		if(status != 1) 
		{
			cardBuffer[columns++]=P14;  //release key
			outColCount+=columns;       //count the columns going out
			fwrite(cardBuffer,2,(columns),out);
			return EOF;
		}
		inColCount++;            // count the columns coming in

		
		inWord=inWord>>4;    //need to shift 4 bits right
		cardBuffer[columns++]=inWord;
	
		if(columns > 79)
		{
			cardBuffer[columns++]=P14;  //release key
			outColCount+=columns;       //count the columns going out
			fwrite(cardBuffer,2,(columns),out);
	  	    return(columns);
		}
	
	}
}